<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_GenFinalForm extends Controller_UserEnvi {
    
    public function action_do()
	{
		// parameters
		//$disciplineID = $this->request->param('disciplineID');
		//$groupID = $this->request->param('groupID');
		$disciplineID = 266;
		$groupID = 11;
		
		// preparation
		$db = new Model_Teacher_Rating;
		$info = $db->getFinalFormInfo($disciplineID, $groupID);
		$type = $info[0]['ExamType'];
		$specName = 
		
		$templateFile = "./docs/template $type.xls";
		if (!file_exists($templateFile)) {
			exit("template wasn't found" . PHP_EOL);
		}
		
		$result = $db->getRatesForStudentsGroup($this->UserInfo['TeacherID'], $disciplineID, $groupID);
		$rowsCount = count($result); // Получаем количество записей 
		
		$objPHPExcel = PHPExcel_IOFactory::load($templateFile);
		$objPHPExcel->setActiveSheetIndex(0);
		
	
		// fill header
		$range = $objPHPExcel->getNamedRange("Discipline")->getRange();
		$objPHPExcel->getActiveSheet()->setCellValue("$range", $info[0]['SubjectName']);
		$range = $objPHPExcel->getNamedRange("Subdivision")->getRange();
		$objPHPExcel->getActiveSheet()->setCellValue("$range", $info[0]['FacultyName']);
		$range = $objPHPExcel->getNamedRange("Major")->getRange();	
		$objPHPExcel->getActiveSheet()->setCellValue("$range", "Специальность: ".$info[0]['SpecName']." ".$info[0]['SpecCode']);
		$range = $objPHPExcel->getNamedRange("Teacher")->getRange();
		$objPHPExcel->getActiveSheet()->setCellValue("$range", $info[0]['LastName']." ".$info[0]['FirstName']." ".$info[0]['SecondName']);
		$range = $objPHPExcel->getNamedRange("Grade")->getRange();
		$objPHPExcel->getActiveSheet()->setCellValue("$range", $info[0]['GradeNum']);
		$range = $objPHPExcel->getNamedRange("Semester")->getRange();
		$objPHPExcel->getActiveSheet()->setCellValue("$range", $info[0]['SemesterNum']);
		$range = $objPHPExcel->getNamedRange("Year")->getRange();
		$objPHPExcel->getActiveSheet()->setCellValue("$range", $info[0]['Year']);
		$range = $objPHPExcel->getNamedRange("CreationDate")->getRange();
		$objPHPExcel->getActiveSheet()->setCellValue("$range", date("m.d.y"));
		$range = $objPHPExcel->getNamedRange("Date")->getRange();
		if ($type == 'exam') 
			$controlDate = '__________';
		else
			$controlDate = '30.12.2014';
		$objPHPExcel->getActiveSheet()->setCellValue("$range", "Дата зачета \n$controlDate");
	
		// fill students rows
		$startRow = 12; 
		$finalRow = 52; 
		$indPosition = 'A'; // Номер 
		$namePosition = 'B';  // ФИО 
		$totalRatePosition = 'G';  // Итоговый рейтинг 
		$semesterRatePosition  = 'H';   // Сумма баллов
		$bonusRatePosition = 'I'; // Бонусные баллы
		$rowNumber = $startRow;
		$index = 1;
		foreach($result as $studentInfo){
			
			$lastName = $studentInfo['Last'];
			$firstName = $studentInfo['First'];
			$secondName = $studentInfo['Second'];
			$rate = (int)$studentInfo['intermediate'];
			$bonus = (int)$studentInfo['bonus'];
			$fullName = "$lastName  $firstName $secondName";
			$totalRate = $rate + $bonus;
       
			$objPHPExcel->getActiveSheet()->setCellValue("$indPosition$rowNumber", "$index")
                                  ->setCellValue("$namePosition$rowNumber", "$fullName")
								  ->setCellValue("$totalRatePosition$rowNumber", "$totalRate")
                                  ->setCellValue("$semesterRatePosition$rowNumber","$rate")
                                  ->setCellValue("$bonusRatePosition$rowNumber","$bonus");
			$rowNumber++;
			$index++;
		}    

		// delete rest rows
		$objPHPExcel->getActiveSheet()->removeRow($rowNumber+1, $finalRow);
   
		$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
		$objWriter->save('./FinalForm.xls'); 
		// TODO: send to user
   }
}
?>